#ifndef __DistributeMat_h__
#define __DistributeMat_h__

#include "Graph.h"
#include "HKLFM.h"
#include "Options.h"
#include "Sort.h"
#include "SparseMatrix.h"

/* Function declarations for DistributeMat.c */

void DistributeMatrixMondriaan(struct sparsematrix *pT, int P, double eps) ;

long ComputeWeight (struct sparsematrix A, long lo, long hi, long *wnz) ;
void BalanceParts (long *weight, long maxweight, int P, int k, int *procs) ;
void DetermineSplit (long *weight, long maxweight, int k, int *procs,
                     int *isplit, long *weightlo, long *weighthi) ;

int logb2(int n) ;

void SplitMatrixKLFM(struct sparsematrix *pT, int k, int i, int dir, 
                     long weightlo, long weighthi) ;
void SplitMatrixSimple(struct sparsematrix *pT, int k, int i,
                       long weightlo, long weighthi) ;

#endif /* __DistributeMat_h__ */
