
#ifndef __DistributeVecLib_h__
#define __DistributeVecLib_h__

#include "IO.h" 
#include "SparseMatrix.h" 


void AssignColumnToProc(int *X, long *procstart, int *procindex,
                        long *Ns, long *Nr, long *Nv, long *Sums,
                        long j, int q) ;
void RemoveColumnFromProc(int *X, long *procstart, int *procindex,
                          long *Ns, long *Nr, long *Nv, long *Sums, 
                          long j, int q) ;
void AssignRemainingColumns(long l, int P, int *X, long *Nv) ;
void AssignRemainingNonemptyColumns(long l, int P, int *X, 
                                    long *procstart, int *procindex,
                                    long *Ns, long *Nr, long *Nv) ;
  
void InitNprocs(struct sparsematrix A, int dir, int *Nprocs) ;
void InitProcindex(struct sparsematrix A, int dir, int *Nprocs,
                   long *procstart, int *procindex) ;

void GenerateHistogram(int *X, long l, int lo, int hi, long *Histogram ) ;
void PrintHistogram(int lo, int hi, long *Histogram) ;

void CalcCom(struct sparsematrix A, int *X, int dir, long *ComVol, 
             long *MaxOut, long *MaxIn, long *MaxCompnts, long *TotCompnts) ;
void PrintCom(int P, long l, int dir, long ComVol, long MaxOut, long MaxIn,
              long MaxCompnts, long TotCompnts) ;
void CalcLocalLowerBound(struct sparsematrix A, int dir, long *LB, int *Pact) ;

void PrintVecStatistics(int P, long *Ns, long *Nr, long *Nv) ;
void WriteVectorDistribution(int *X, long l, int P, char *filename) ;
 
#endif /* __DistributeVecLib_h__ */
