#ifndef __HKLFM_h__
#define __HKLFM_h__

#include "IO.h"
#include "Graph.h"
#include "GainBucket.h"
#include "Match.h"

/*** function declarations for HKLFM.c ***/
void CreateInitialBalancedPartition(struct biparthypergraph *pHG,
                                    long weightlo, long weighthi) ;
void ComputeInitialGains(struct biparthypergraph *pHG) ;
void ClearMoveLog(struct biparthypergraph *pHG) ;
void MoveVertex(struct biparthypergraph *pHG, long v) ;
void UpdateGains(struct biparthypergraph *pHG, long v) ;

void HKLFM(struct biparthypergraph *pHG, long weightlo, long weighthi,
           int MaxNrLoops, int MaxNrNoGainMoves) ;
void RunHKLFM(struct biparthypergraph *pHG, long weightlo, long weighthi,
              int refine) ;

struct contraction CoarsenGraph(struct biparthypergraph *pHG,
                                struct biparthypergraph *pCHG, long level) ;
void RunMLGraphPart(struct biparthypergraph *pHG, long weightlo, long weighthi) ;


#endif /* __HKLFM_h__ */
