/* This header file includes standard libraries,
   defines universal constants ROW, COL, FALSE, TRUE,
   and maximum word and line lengths and macros MIN, MAX. */

#ifndef __IO_h__
#define __IO_h__

/* Standard libraries */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <float.h>
#include <limits.h>
#include <string.h>
#include <time.h>

#ifdef UNIX
#include <sys/time.h>
#endif

/* Directions in matrix */
#define ROW   0
#define COL   1 
#define FINEGRAIN 2

/* Logical constants */
#define FALSE 0
#define TRUE  1

/* Dummy negative value, cannot be an index.
Not to be confused with dummy diagonal nonzero */
#define DUMMY -1

/* Maximum lengths */
#define MAX_WORD_LENGTH 999
#define MAX_LINE_LENGTH 9999

/* Macros */
#define MIN(a, b)       ( (a) < (b) ? (a) : (b) )
#define MAX(a, b)       ( (a) > (b) ? (a) : (b) )

/* Function declarations for IO.c */
FILE *OpenFile(char *filename, char *mode) ;
void CloseFile(char *filename, FILE *stream) ;
void Abort(char *error) ;

#endif /* __IO_h__ */
