#ifndef __Match_h__
#define __Match_h__

#include "IO.h"
#include "Graph.h"

/*** Contraction data structure ***/
typedef struct contraction {
  long *Match ;        /* Array containing the vertex numbers of
                          matched vertices, with the vertices of each
                          group stored contiguously */
  long *Start ;        /* Start[k] = the start in array Match of the
                          vertices of group k */
  long NrMatches ;     /* Nr of groups of matched vertices */
  long MaxNrVertices ; /* Maximum number of vertices allowed in a group.
                          For pairwise matching, MaxNrVertices = 2 */
  long MaxVtxWgt ;     /* Maximum total vertex weight allowed in a group */
} Contraction ;

/*** Function declarations for Match.c ***/
void MoveVtxInNetAdjncy(struct biparthypergraph *pHG, long v) ;
void FindMatchArbitrary(struct biparthypergraph *pHG, struct contraction *pC,
                        long v, int *Matched) ;
void FindMatchInprod(struct biparthypergraph *pHG, struct contraction *pC,
                     long v, int *Matched,
                     long *Visited, long *Inprod, double *ScInprod) ;
void FindMatchInprod_FineGrain(struct biparthypergraph *pHG,
                               struct contraction *pC,
                               long v, int *Matched, long *Visited, long *Inprod,
                               long *NetStart, long *NetEnd, int level) ;

#endif /* __Match_h__ */
