#include "DistributeMat.h"

struct opts Options ;

int main(int argc, char **argv) {

    struct sparsematrix A ;
    long n, i, j, t, P, weightlo, weighthi, weight0, weight1;

    printf("Test SplitMatrixSimple: ");
    n = 33 ; /* n by n dense matrix A, n odd */
    A.m = n;
    A.n = n;
    A.NrNzElts = n*n ;
    P = 2; /* maximum number of parts */

    A.i = (long *) malloc(A.NrNzElts* sizeof(long)) ;
    A.j = (long *) malloc(A.NrNzElts* sizeof(long)) ;
    A.Pstart = (long *) malloc((P+1)* sizeof(long)) ;

    if ( A.i == NULL || A.j  == NULL || A.Pstart  == NULL ){
        printf("Error\n") ;
        exit(1);
    }

    /* Fill matrix with nonzeros */
    t= 0;
    for (i=0; i<n; i++){
        for (j=0; j<n; j++){
            A.i[t] = i ;
            A.j[t] = j ;
            t++;
        }
    }

    A.MMTypeCode[3]='G';
    A.NrDummies = 0 ;
    A.Pstart[0] = 0 ;
    A.Pstart[1] = A.NrNzElts ;

    weightlo = (n*n)/2 ;
    weighthi = (n*n)/2 + 1;
    SplitMatrixSimple(&A, 1, 0, weightlo, weighthi );

    /* Check result */
    if ( A.Pstart[0] != 0 || A.Pstart[1] != (n*n)/2 ||
         A.Pstart[2] != A.NrNzElts ){
        printf("Error\n") ;
        exit(1);
    }
    weight0 = ComputeWeight(A, A.Pstart[0], A.Pstart[1]-1, NULL) ;
    weight1 = ComputeWeight(A, A.Pstart[1], A.Pstart[2]-1, NULL) ;

    if ( weight0 != weightlo || weight1 != weighthi ){
        printf("Error\n") ;
        exit(1);
    }

    printf("OK\n") ;
    exit(0);

} /* end main */
